//=--------------------------------------------------------------------------=
// LocalizeCtl.H
//=--------------------------------------------------------------------------=
// Copyright  1995  Microsoft Corporation.  All Rights Reserved.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=
//
// class declaration for the Localize control.
//
#ifndef _LOCALIZECONTROL_H_

#include "IPServer.H"
#include "CtrlObj.H"
#include "LocalizeInterfaces.H"
#include "Dispids.H"

typedef struct tagLOCALIZECTLSTATE {

    // TOOD: put state variables here, and probably get rid of fGarbage, unless
    // you have a real need for it
    //
    VARIANT_BOOL fGarbage;

} LOCALIZECTLSTATE;

//=--------------------------------------------------------------------------=
// CLocalizeControl
//=--------------------------------------------------------------------------=
// our control.
//
class CLocalizeControl : public COleControl, public ILocalize, public ISupportErrorInfo {

  public:
    // IUnknown methods
    //
    DECLARE_STANDARD_UNKNOWN();

    // IDispatch methods
    //
    DECLARE_STANDARD_DISPATCH();

    // ISupportErrorInfo methods
    //
    DECLARE_STANDARD_SUPPORTERRORINFO();

    // ILocalize methods
    //
    // TODO: copy over the method declarations from LocalizeInterfaces.H
    //       don't forget to remove the PURE from them.
    //
    STDMETHOD_(void, AboutBox)(THIS);

    // OLE Control stuff follows:
    //
    CLocalizeControl(IUnknown *pUnkOuter);
    virtual ~CLocalizeControl();

    // static creation function.  all controls must have one of these!
    //
    static IUnknown *Create(IUnknown *);

  private:
    // overridables that the control must implement.
    //
    STDMETHOD(LoadBinaryState)(IStream *pStream);
    STDMETHOD(SaveBinaryState)(IStream *pStream);
    STDMETHOD(LoadTextState)(IPropertyBag *pPropertyBag, IErrorLog *pErrorLog);
    STDMETHOD(SaveTextState)(IPropertyBag *pPropertyBag, BOOL fWriteDefault);
    STDMETHOD(OnDraw)(HDC hdcDraw, LPCRECTL prcBounds, LPCRECTL prcWBounds, HDC hicTargetDev);
    virtual LRESULT WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
    virtual BOOL    RegisterClassData(void);

    virtual HRESULT InternalQueryInterface(REFIID, void **);
    virtual void    BeforeCreateWindow(void);

    // private state information.
    //
    LOCALIZECTLSTATE m_state;
};


// TODO: if you have an array of verbs, then add an extern here with the name
//       of it, so that you can include it in the DEFINE_CONTROLOBJECT.
//       ie.  extern VERBINFO m_LocalizeCustomVerbs [];
//
extern const GUID    *rgLocalizePropPages [];
DEFINE_CONTROLOBJECT(Localize,
    &CLSID_Localize,
    "LocalizeCtl",
    CLocalizeControl::Create,
    1,
    &IID_ILocalize,
    "Localize.HLP",
    &DIID_DLocalizeEvents,
    OLEMISC_SETCLIENTSITEFIRST|OLEMISC_ACTIVATEWHENVISIBLE|OLEMISC_RECOMPOSEONRESIZE|OLEMISC_CANTLINKINSIDE|OLEMISC_INSIDEOUT,
    RESID_TOOLBOX_BITMAP,
    "LocalizeWndClass",
    1,
    rgLocalizePropPages,
    0,
    NULL);



#define _LOCALIZECONTROL_H_
#endif // _LOCALIZECONTROL_H_


